JettyRun (Gradle API 2.9)
Date: 2015-11-17

Package: org.gradle.api.plugins.jetty

## [Java] Class JettyRun

- org.gradle.api.plugins.jetty.JettyRun

- Deploys an exploded web application to an embedded Jetty web container. Does not require that the web application be assembled into a war, saving time during the development cycle.

  Once started, the web container can be configured to run continuously, scanning for changes in the project and automatically performing a hot redeploy when necessary. This allows the developer to concentrate on coding changes to the project using their IDE of choice and have those changes immediately and transparently reflected in the running web container, eliminating development time that is wasted on rebuilding, reassembling and redeploying.

- - Inherited fields
    Fields inherited from class | Fields
    --- | ---
    `class AbstractJettyRunTask` | `PORT_SYSPROPERTY, consoleScanner, reload, scannerListeners`
    `class org.gradle.api.internal.ConventionTask` | `TASK_NAME, TASK_DESCRIPTION, TASK_GROUP, TASK_TYPE, TASK_DEPENDS_ON, TASK_OVERWRITE, TASK_ACTION`

  - ### Methods Summary

    Methods
    Type | Name and description
    --- | ---
    `void` | `applyJettyXml()`
    `void` | `configureScanner()`
    `void` | `configureWebApplication()`
    `org.gradle.api.plugins.jetty.internal.JettyPluginServer` | `createServer()`
    `void` | `finishConfigurationBeforeStart()`
    `List<File>` | `getClassPathFiles()`
    `FileCollection` | `getClasspath()` Returns the classpath for the web application.
    `org.mortbay.jetty.handler.ContextHandler[]` | `getConfiguredContextHandlers()`
    `Set<File>` | `getExtraScanTargets()`
    `File` | `getJettyEnvXml()`
    `File` | `getJettyEnvXmlFile()`
    `ScanTargetPattern[]` | `getScanTargetPatterns()`
    `File[]` | `getScanTargets()`
    `File` | `getWebAppSourceDirectory()` Returns the directory containing the web application source files.
    `File` | `getWebXml()` Returns the `web.xml` file to use.
    `void` | `restartWebApp(boolean reconfigureScanner)`
    `void` | `setClassPathFiles(List<File> classPathFiles)`
    `void` | `setClasspath(FileCollection classpath)` Set the classpath for the web application.
    `void` | `setContextHandlers(org.mortbay.jetty.handler.ContextHandler[] contextHandlers)`
    `void` | `setExtraScanTargets(Iterable<File> extraScanTargets)`
    `void` | `setJettyEnvXml(File jettyEnvXml)`
    `void` | `setJettyEnvXmlFile(File jettyEnvXmlFile)`
    `void` | `setScanTargetPatterns(ScanTargetPattern[] scanTargetPatterns)`
    `void` | `setScanTargets(File[] scanTargets)`
    `void` | `setWebAppSourceDirectory(File webAppSourceDirectory)`
    `void` | `setWebXml(File webXml)`
    `void` | `validateConfiguration()`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class AbstractJettyRunTask` | `applyJettyXml, configureScanner, configureWebApplication, createServer, findJettyWebXmlFile, finishConfigurationBeforeStart, getAdditionalRuntimeJars, getConnectors, getContextPath, getHttpPort, getJettyConfig, getOverrideWebXml, getReload, getRequestLog, getScanIntervalSeconds, getScanner, getScannerListeners, getServer, getStopKey, getStopPort, getUserRealms, getWebAppConfig, getWebDefaultXml, isDaemon, restartWebApp, setAdditionalRuntimeJars, setConnectors, setContextPath, setDaemon, setHttpPort, setJettyConfig, setOverrideWebXml, setReload, setRequestLog, setScanIntervalSeconds, setScannerListeners, setServer, setStopKey, setStopPort, setUserRealms, setWebAppConfig, setWebDefaultXml, start, startConsoleScanner, startJetty, startJettyInternal, validateConfiguration`
    `class org.gradle.api.internal.ConventionTask` | `org.gradle.api.internal.ConventionTask#conventionMapping(java.lang.String, groovy.lang.Closure), org.gradle.api.internal.ConventionTask#conventionMapping(java.lang.String, java.util.concurrent.Callable), org.gradle.api.internal.ConventionTask#getConventionMapping(), org.gradle.api.internal.ConventionTask#setProperty(java.lang.String, java.lang.Object), org.gradle.api.internal.ConventionTask#toString(), org.gradle.api.internal.ConventionTask#compareTo(org.gradle.api.Task), org.gradle.api.internal.ConventionTask#compareTo(java.lang.Object), org.gradle.api.internal.ConventionTask#getName(), org.gradle.api.internal.ConventionTask#getActions(), org.gradle.api.internal.ConventionTask#getState(), org.gradle.api.internal.ConventionTask#getState(), org.gradle.api.internal.ConventionTask#setName(java.lang.String), org.gradle.api.internal.ConventionTask#getPath(), org.gradle.api.internal.ConventionTask#getExtensions(), org.gradle.api.internal.ConventionTask#getLogger(), org.gradle.api.internal.ConventionTask#execute(), org.gradle.api.internal.ConventionTask#configure(groovy.lang.Closure), org.gradle.api.internal.ConventionTask#configure(groovy.lang.Closure), org.gradle.api.internal.ConventionTask#getDescription(), org.gradle.api.internal.ConventionTask#leftShift(groovy.lang.Closure), org.gradle.api.internal.ConventionTask#isEnabled(), org.gradle.api.internal.ConventionTask#property(java.lang.String), org.gradle.api.internal.ConventionTask#setEnabled(boolean), org.gradle.api.internal.ConventionTask#getOutputs(), org.gradle.api.internal.ConventionTask#getOutputs(), org.gradle.api.internal.ConventionTask#getShouldRunAfter(), org.gradle.api.internal.ConventionTask#getProject(), org.gradle.api.internal.ConventionTask#getTaskDependencies(), org.gradle.api.internal.ConventionTask#getTaskDependencies(), org.gradle.api.internal.ConventionTask#setActions(java.util.List), org.gradle.api.internal.ConventionTask#setOnlyIf(org.gradle.api.specs.Spec), org.gradle.api.internal.ConventionTask#setOnlyIf(groovy.lang.Closure), org.gradle.api.internal.ConventionTask#setDidWork(boolean), org.gradle.api.internal.ConventionTask#getDidWork(), org.gradle.api.internal.ConventionTask#doFirst(groovy.lang.Closure), org.gradle.api.internal.ConventionTask#doFirst(org.gradle.api.Action), org.gradle.api.internal.ConventionTask#doLast(org.gradle.api.Action), org.gradle.api.internal.ConventionTask#doLast(groovy.lang.Closure), org.gradle.api.internal.ConventionTask#deleteAllActions(), org.gradle.api.internal.ConventionTask#getEnabled(), org.gradle.api.internal.ConventionTask#getAnt(), org.gradle.api.internal.ConventionTask#getLogging(), org.gradle.api.internal.ConventionTask#getLogging(), org.gradle.api.internal.ConventionTask#hasProperty(java.lang.String), org.gradle.api.internal.ConventionTask#getConvention(), org.gradle.api.internal.ConventionTask#setDescription(java.lang.String), org.gradle.api.internal.ConventionTask#getGroup(), org.gradle.api.internal.ConventionTask#setGroup(java.lang.String), org.gradle.api.internal.ConventionTask#dependsOnTaskDidWork(), org.gradle.api.internal.ConventionTask#getInputs(), org.gradle.api.internal.ConventionTask#getTemporaryDir(), org.gradle.api.internal.ConventionTask#mustRunAfter([Ljava.lang.Object;), org.gradle.api.internal.ConventionTask#setMustRunAfter(java.lang.Iterable), org.gradle.api.internal.ConventionTask#getMustRunAfter(), org.gradle.api.internal.ConventionTask#finalizedBy([Ljava.lang.Object;), org.gradle.api.internal.ConventionTask#setFinalizedBy(java.lang.Iterable), org.gradle.api.internal.ConventionTask#getFinalizedBy(), org.gradle.api.internal.ConventionTask#shouldRunAfter([Ljava.lang.Object;), org.gradle.api.internal.ConventionTask#setShouldRunAfter(java.lang.Iterable), org.gradle.api.internal.ConventionTask#getDependsOn(), org.gradle.api.internal.ConventionTask#setDependsOn(java.lang.Iterable), org.gradle.api.internal.ConventionTask#dependsOn([Ljava.lang.Object;), org.gradle.api.internal.ConventionTask#onlyIf(org.gradle.api.specs.Spec), org.gradle.api.internal.ConventionTask#onlyIf(groovy.lang.Closure), org.gradle.api.internal.ConventionTask#getStandardOutputCapture(), org.gradle.api.internal.ConventionTask#getAsDynamicObject(), org.gradle.api.internal.ConventionTask#setProject(org.gradle.api.Project), org.gradle.api.internal.ConventionTask#prependParallelSafeAction(org.gradle.api.Action), org.gradle.api.internal.ConventionTask#injectIntoNewInstance(org.gradle.api.internal.project.ProjectInternal, java.lang.String, java.util.concurrent.Callable), org.gradle.api.internal.ConventionTask#getTaskActions(), org.gradle.api.internal.ConventionTask#getOnlyIf(), org.gradle.api.internal.ConventionTask#getImpliesSubProjects(), org.gradle.api.internal.ConventionTask#setImpliesSubProjects(boolean), org.gradle.api.internal.ConventionTask#getExecuter(), org.gradle.api.internal.ConventionTask#setExecuter(org.gradle.api.internal.tasks.TaskExecuter), org.gradle.api.internal.ConventionTask#getTemporaryDirFactory(), org.gradle.api.internal.ConventionTask#addValidator(org.gradle.api.internal.tasks.execution.TaskValidator), org.gradle.api.internal.ConventionTask#getValidators(), org.gradle.api.internal.ConventionTask#appendParallelSafeAction(org.gradle.api.Action), org.gradle.api.internal.ConventionTask#isHasCustomActions(), org.gradle.api.internal.ConventionTask#wait(long, int), org.gradle.api.internal.ConventionTask#wait(long), org.gradle.api.internal.ConventionTask#wait(), org.gradle.api.internal.ConventionTask#equals(java.lang.Object), org.gradle.api.internal.ConventionTask#hashCode(), org.gradle.api.internal.ConventionTask#getClass(), org.gradle.api.internal.ConventionTask#notify(), org.gradle.api.internal.ConventionTask#notifyAll()`

- - ### Method Detail

    - #### public void applyJettyXml()

    - #### public void configureScanner()

    - #### public void configureWebApplication()

    - #### public org.gradle.api.plugins.jetty.internal.JettyPluginServer createServer()

    - #### public void finishConfigurationBeforeStart()

    - #### public List<File> getClassPathFiles()

    - #### @InputFiles public FileCollection getClasspath()

      Returns the classpath for the web application.

    - #### public org.mortbay.jetty.handler.ContextHandler[] getConfiguredContextHandlers()

    - #### public Set<File> getExtraScanTargets()

    - #### @InputFile @Optional public File getJettyEnvXml()

    - #### @InputFile @Optional public File getJettyEnvXmlFile()

    - #### public ScanTargetPattern[] getScanTargetPatterns()

    - #### public File[] getScanTargets()

    - #### @InputDirectory public File getWebAppSourceDirectory()

      Returns the directory containing the web application source files.

    - #### public File getWebXml()

      Returns the `web.xml` file to use. When `null`, no `web.xml` file is used.

    - #### public void restartWebApp(boolean reconfigureScanner)

    - #### public void setClassPathFiles(List<File> classPathFiles)

    - #### public void setClasspath(FileCollection classpath)

      Set the classpath for the web application.

    - #### public void setContextHandlers(org.mortbay.jetty.handler.ContextHandler[] contextHandlers)

    - #### public void setExtraScanTargets(Iterable<File> extraScanTargets)

    - #### public void setJettyEnvXml(File jettyEnvXml)

    - #### public void setJettyEnvXmlFile(File jettyEnvXmlFile)

    - #### public void setScanTargetPatterns(ScanTargetPattern[] scanTargetPatterns)

    - #### public void setScanTargets(File[] scanTargets)

    - #### public void setWebAppSourceDirectory(File webAppSourceDirectory)

    - #### public void setWebXml(File webXml)

    - #### public void validateConfiguration()